class com.techsmith.utils.ToolTip extends MovieClip
{
   var onEnterFrame;
   var label = null;
   var format = null;
   var background = null;
   var metricsObj = null;
   var stageHeight = 0;
   function ToolTip()
   {
      super();
   }
   function init(tip, constraint)
   {
      this.createFormat(tip,constraint);
      this.createTip(this.metricsObj);
      this.label.text = tip;
      this.label.setTextFormat(this.format);
      var _loc2_ = 25;
      if(this._parent._ymouse + 40 + this._height >= this._parent._height)
      {
         _loc2_ = -25;
      }
      this.move(this._parent._xmouse,this._parent._ymouse + _loc2_);
      this.onEnterFrame = this.chaseMouse;
   }
   function move(x, y)
   {
      this._x = x;
      this._y = y;
   }
   function kill()
   {
      delete this.onEnterFrame;
      this.removeMovieClip();
   }
   function chaseMouse()
   {
      var _loc2_ = 25;
      var _loc3_ = this._height + _loc2_;
      var _loc4_ = this.stageHeight - this._parent._ymouse;
      if(_loc3_ > _loc4_)
      {
         _loc2_ -= _loc3_;
      }
      this.move(this._parent._xmouse,this._parent._ymouse + _loc2_);
   }
   function createFormat(text, constraint)
   {
      this.format = new TextFormat();
      this.format.font = "_sans";
      this.format.size = 12;
      this.format.align = "left";
      this.format.leftMargin = 5;
      this.format.rightMargin = 5;
      if(constraint == undefined || constraint == null)
      {
         this.metricsObj = this.format.getTextExtent(text);
      }
      else
      {
         this.metricsObj = this.format.getTextExtent(text);
         if(this.metricsObj.textFieldWidth > constraint)
         {
            this.metricsObj = this.format.getTextExtent(text,constraint);
         }
      }
      this.metricsObj.textFieldWidth += 15;
   }
   function createTip(metrics)
   {
      this.stageHeight = Stage.height;
      this.background = this.createEmptyMovieClip("background",1);
      this.background._visible = false;
      com.techsmith.utils.shapes.Rectangle.draw(this.background,16777185,metrics.textFieldWidth,metrics.textFieldHeight,100,{thickness:1,rgb:0,alpha:100});
      this.createTextField("label",2,0,0,metrics.textFieldWidth,metrics.textFieldHeight);
      this.label.autoSize = true;
      this.label.multiline = true;
      this.label.wordWrap = true;
      this.label.selectable = false;
      var _loc2_ = 25;
      var _loc4_ = this._height + _loc2_;
      var _loc5_ = this.stageHeight - this._parent._ymouse;
      if(_loc4_ > _loc5_)
      {
         _loc2_ -= _loc4_;
      }
      this.move(this._parent._xmouse,this._parent._ymouse + _loc2_);
      this.background._visible = true;
   }
}
