class com.techsmith.widgets.text.TSTextField extends com.techsmith.widgets.Movable implements com.techsmith.utils.events.IEventDispatcher
{
   var m_dispatcher = null;
   var m_text = "";
   var m_textField = null;
   var m_textFormat = null;
   var m_width = null;
   var m_height = 27;
   var m_fieldProperties = null;
   var m_decoration = null;
   var m_highlight = null;
   var m_disabledHighlight = null;
   var m_defaultColor = "666666";
   var m_fpVersion = null;
   var m_type = null;
   function TSTextField()
   {
      super();
      this.m_dispatcher = new com.techsmith.utils.events.EventDispatcher();
      this.m_fpVersion = com.techsmith.utils.Capabilities.getInstance().getFlashPlayerMajorVersion();
   }
   static function create(container, name, depth, init)
   {
      var _loc1_ = container.attachMovie("TSTextField",name,depth,init);
      return com.techsmith.widgets.text.TSTextField(_loc1_);
   }
   function init(w, h, format, props)
   {
      this.m_width = w;
      this.m_height = h;
      this.m_textFormat = format;
      this.m_fieldProperties = props;
      this.draw();
   }
   function draw()
   {
      this.createField();
      this.createFormat();
      this.decorate();
      this.setEventCallbacks();
   }
   function createField()
   {
      this.createTextField("m_textField",3,3,3,this.m_width - 6,this.m_height - 6);
      this.m_textField.type = "input";
      this.m_textField.html = true;
      for(var _loc2_ in this.m_fieldProperties)
      {
         this.m_textField[_loc2_] = this.m_fieldProperties[_loc2_];
      }
      this.m_type = this.m_textField.type;
   }
   function createFormat()
   {
      if(this.m_textFormat == null || this.m_textFormat == undefined)
      {
         this.m_textFormat = new TextFormat();
         this.m_textFormat.align = "left";
         this.m_textFormat.font = "Arial";
         this.m_textFormat.bold = false;
         this.m_textFormat.size = 14;
         this.m_textFormat.color = 6710886;
         this.m_textFormat.leftMargin = 4;
      }
      else
      {
         this.m_defaultColor = String(this.m_textFormat.color);
      }
      this.m_textField.setNewTextFormat(this.m_textFormat);
   }
   function decorate()
   {
      this.m_decoration = this.createEmptyMovieClip("m_decoration",1);
      com.techsmith.utils.shapes.Rectangle.draw(this.m_decoration,null,this.m_width,this.m_height,null,{thickness:0.5,rgb:13158600,alpha:100},{x:0,y:0});
      com.techsmith.utils.shapes.Rectangle.draw(this.m_decoration,16777215,this.m_width - 4,this.m_height - 4,100,{thickness:0.5,rgb:13158600,alpha:100},{x:2,y:2});
   }
   function drawFocusHighlight()
   {
      this.m_highlight = this.createEmptyMovieClip("m_highlight",2);
      com.techsmith.utils.shapes.Rectangle.draw(this.m_highlight,null,this.m_width,this.m_height,null,{thickness:1,rgb:11066869,alpha:100},{x:0,y:0});
   }
   function drawDisabled()
   {
      this.m_disabledHighlight = this.createEmptyMovieClip("m_disabledHighlight",4);
      com.techsmith.utils.shapes.Rectangle.draw(this.m_disabledHighlight,16777215,this.m_width,this.m_height,60,null,{x:0,y:0});
   }
   function setEventCallbacks()
   {
      this.m_textField.onSetFocus = com.techsmith.utils.Delegate.create(this,this.onSetFocus);
      this.m_textField.onKillFocus = com.techsmith.utils.Delegate.create(this,this.onKillFocus);
      this.m_textField.addListener(this);
   }
   function setText(s)
   {
      this.m_text = s;
      if(this.m_textField.html)
      {
         this.m_textField.htmlText = s;
      }
      else
      {
         this.m_textField.text = s;
      }
      this.m_textField.setTextFormat(this.m_textFormat);
   }
   function getText()
   {
      return this.m_text;
   }
   function setEnabled(bEnabled)
   {
      if(bEnabled)
      {
         this.focusEnabled = true;
         this.m_textField.type = this.m_type;
         this.m_textField.selectable = true;
         this.m_disabledHighlight.removeMovieClip();
      }
      else
      {
         this.onKillFocus();
         this.focusEnabled = false;
         this.m_textField.selectable = false;
         this.m_textField.type = "dynamic";
         this.drawDisabled();
      }
   }
   function setBorderVisibility(bVisible)
   {
      this.m_decoration._visible = bVisible;
   }
   function onSetFocus(oldFocus)
   {
      this.drawFocusHighlight();
      Key.addListener(this);
      this.sendEvent({target:this,type:"focusIn"});
   }
   function onKillFocus(newFocus)
   {
      Key.removeListener(this);
      this.m_highlight.removeMovieClip();
      this.sendEvent({target:this,type:"focusOut"});
   }
   function onChanged()
   {
      this.m_text = this.m_textField.text;
      this.sendEvent({target:this,type:"change"});
   }
   function onKeyDown()
   {
      if(Key.getCode() == 13)
      {
         this.sendEvent({target:this,type:"enter"});
      }
   }
   function onUnload()
   {
      Key.removeListener(this);
      this.m_dispatcher.removeAllListeners();
   }
   function sendEvent(e)
   {
      this.dispatchEvent(e);
   }
   function addEventListener(event, scope)
   {
      this.m_dispatcher.addEventListener(event,scope);
   }
   function removeEventListener(event, scope)
   {
      this.m_dispatcher.removeEventListener(event,scope);
   }
   function dispatchEvent(eventObj)
   {
      this.m_dispatcher.dispatchEvent(eventObj);
   }
}
